import Qt 4.7
import QtWebKit 1.0

import "imports/XAComponents"
import "imports/WebBrowserContent"
import "imports/colibri"
//import "imports/XAComponents/date.js" as DateFunctions

Item {
    id: dtsEditor
    width: 560
    height: 435
    anchors.fill: parent

    property string windowTitle : qtInputTitle
    property string windowGotFocus : qtWindowGotFocus
    property string windowDisplaysItemOfType: qtItemType
    property string windowDisplaysItemWithUID: qtItemUID
    property string platformID: qtPlatformID

    property string collectionFolderType : qtInputFolderType
    property string collectionFolderFlagged: qtInputFolderFlagged
    property string collectionStatusTrafficLight : qtInputTrafficLight
    property string collectionStatusActivity: qtInputDTSActivity
    property string collectionDTSStart : qtInputDTSStart
    property string collectionDTSStartSQLDate : qtInputDTSStartSQLDate
    property string collectionDTSDue : qtInputDTSDue
    property string collectionDTSDueSQLDate : qtInputDTSDueSQLDate

    property string collectionDefaultItemPriority : qtInputDefaultItemPriority
    property string collectionDefaultItemType : qtInputDefaultItemType
    property string collectionDefaultItemSecurity : qtInputDefaultItemSecurity
    property string collectionDefaultContext : qtInputDefaultContext
    property string raciResponsible : qtInputRACIResponsible
    property string raciAccountible : qtInputRACIAccountible
    property string raciConsulted : qtInputRACIConsulted
    property string raciInformed : qtInputRACIInformed

    property string contextContactName : qtInputContactName
    property string contextContactEmail : qtInputContactEmail
    property string contextContactPhone : qtInputContactPhone
    property string contextContactOrganization : qtInputContactOrganization
    property string contextContactDivision : qtInputContactDivision

    property string contextLocationName : qtInputLocationName
    property string contextLocationStreet : qtInputLocationStreet
    property string contextLocationCity : qtInputLocationCity
    property string contextLocationZIP : qtInputLocationZIP
    property string contextLocationCountry : qtInputLocationCountry

    property bool fieldChange : false

    property int activeInputFieldID : 0

    signal contextAssignmentChanged();

    Keys.enabled: true
//    Keys.onCancelPressed: QtWindow.hide()
//    Keys.onEscapePressed: QtWindow.hide()
    Keys.onCancelPressed: QtHandler.CloseButtonClicked();
    Keys.onEscapePressed: QtHandler.CloseButtonClicked();
    Keys.onEnterPressed: {
//        console.debug("QML++ onEnterPressed")
        reviewAllDataForChanges()
    }

    onContextContactPhoneChanged: {
//        console.debug("QML++ onContextContactPhoneChanged")
//        console.debug(contextContactPhone)
    }

    function updatePanelSelection() {
//        console.debug("QML++ updatePanelSelection")
//        console.debug(windowDisplaysItemOfType)
//        console.debug(windowDisplaysItemWithUID)

        // load panel for item type
        // P = Project
        // C = Context
        // All others are internal

        if (windowDisplaysItemOfType == "P") {
            tabProjectDetailsEditor.visible = true
            tabContextDetailsEditor.visible = false
            tabInternalDetailsEditor.visible = false

        } else if (windowDisplaysItemOfType == "C") {
            tabProjectDetailsEditor.visible = false
            tabContextDetailsEditor.visible = true
            tabInternalDetailsEditor.visible = false

            locationWebview.url = ""
            locationWebview.visible = false
            locationWebviewPlaceholder.visible = true

        } else {
            tabProjectDetailsEditor.visible = false
            tabContextDetailsEditor.visible = false
            tabInternalDetailsEditor.visible = true
        }

        //setActiveInputFieldByID(0)
    }

    function loadItemStarting() {
//        console.debug("QML++ loadItemStarting")

        framedTextContextContactName.focus = false
        framedTextContextContactEmail.focus = false
        framedTextContextContactPhone.focus = false
        framedTextContextContactOrganization.focus = false
        framedTextContextContactDivision.focus = false
        framedTextContextLocationName.focus = false
        framedTextContextLocationStreet.focus = false
        framedTextContextLocationCity.focus = false
        framedTextContextLocationZIP.focus = false
        framedTextContextLocationCountry.focus = false
    }

    function activateFirstInputOnPanel() {
//        console.debug("QML++ activateFirstInputOnPanel")
//        console.debug(windowDisplaysItemOfType)
//        console.debug(windowDisplaysItemWithUID)

        setActiveInputFieldByID(0)
    }

    onCollectionFolderTypeChanged: {
//        console.debug("QML++ onCollectionFolderTypeChanged")
        collectionFolderChanged()
    }

    onCollectionFolderFlaggedChanged: {
//        console.debug("QML++ onCollectionFolderFlaggedChanged: " + collectionFolderFlagged)
        collectionFolderChanged()
    }

    onCollectionStatusActivityChanged: {
//        console.debug("QML++ onCollectionStatusActivityChanged")
        collectionFolderChanged()
    }

    onCollectionStatusTrafficLightChanged: {
//        console.debug("QML++ onCollectionStatusTrafficLightChanged")
        collectionFolderChanged()
    }

    function collectionFolderChanged() {
//        console.debug("QML++ collectionFolderChanged")

        var temp = "";

        if (collectionFolderFlagged == "1") temp = qsTr("Flagged ");

        // load text for overview section
        if (collectionFolderType == "1") temp += qsTr("Folder");
        else if (collectionFolderType == "2") temp += qsTr("Meeting");
        else temp += qsTr("Project");

        temp += " (";

        if (collectionStatusTrafficLight == "1") temp += qsTr("Yellow");
        else if (collectionStatusTrafficLight == "2") temp += qsTr("Red");
        else temp += qsTr("Green");

        temp += ", ";

        if (collectionStatusActivity == "1") temp += qsTr("On Hold");
        else if (collectionStatusActivity == "2") temp += qsTr("Cancelled");
        else if (collectionStatusActivity == "3") temp += qsTr("Completed");
        else temp += "Active";

        temp += ")";

        framedTextInputFolderType.text = temp
        //setActiveInputFieldByID(0)

        // re-load details section
        if (activeInputFieldID == 0) {
            xaqmlfoldertypepicker.folderFlagged = (collectionFolderFlagged == "1") ? true : false;
            xaqmlfoldertypepicker.folderTypeString = collectionFolderType
            xaqmlfoldertypepicker.folderActivityString = collectionStatusActivity
            xaqmlfoldertypepicker.folderTrafficLightString = collectionStatusTrafficLight
        }
    }

    onCollectionDefaultItemPriorityChanged: {
//        console.debug("QML++ onCollectionDefaultItemPriorityChanged")
        collectionDefaultItemChanged()
    }

    onCollectionDefaultItemTypeChanged: {
//        console.debug("QML++ onCollectionDefaultItemTypeChanged")
        collectionDefaultItemChanged()
    }

    onCollectionDefaultItemSecurityChanged: {
//        console.debug("QML++ onCollectionDefaultItemSecurityChanged")
        collectionDefaultItemChanged()
    }

    function collectionDefaultItemChanged() {
//        console.debug("QML++ collectionDefaultItemChanged")

        // load text for overview section
        var temp = qsTr("None");

        if (collectionDefaultItemPriority == "1") temp = qsTr("Normal Priority");
        else if (collectionDefaultItemPriority == "2") temp = qsTr("Medium Priority");
        else if (collectionDefaultItemPriority == "3") temp = qsTr("High Priority");
        else temp = qsTr("Low Priority");

        temp += " ";

        if (collectionDefaultItemType == "1") temp += qsTr("Information");
        else if (collectionDefaultItemType == "2") temp += qsTr("Decision");
        else temp += qsTr("Action");

        temp += " L" + collectionDefaultItemSecurity;

        //tiDefaultSettings.text = temp
        framedTextInputDefaultItemSettings.text = temp

        // re-load details section
        if (activeInputFieldID == 4) {
            xaqmlfoldersettingspicker.folderDefaultItemPriorityString = collectionDefaultItemPriority
            xaqmlfoldersettingspicker.folderDefaultItemTypeString = collectionDefaultItemType
            xaqmlfoldersettingspicker.folderDefaultItemSecurityLevel = collectionDefaultItemSecurity
        }
    }

    function reviewAllDataForChanges() {

    }

    function setDatePicker(d) {
//        console.debug(d.toString() + " --> " + d.getFullYear() + "-" + d.getMonth()+1 + "-" + d.getDate())

        xaqmldatepicker.theYear = d.getFullYear()
        xaqmldatepicker.theMonth = d.getMonth()+1
        xaqmldatepicker.theDay = d.getDate()

        xaqmldatepicker.theTime = d.toLocaleTimeString()

        xaqmldatepicker.loadSelectedMonth();
        xaqmldatepicker.loadSelectedTime();
    }

    function setDatePickerFromString(text) {
//        console.debug("<< setDatePickerFromString: " + text)

        var date = new Date()

        if (text === '' || date == null) {
            xaqmldatepicker.loadNow()
            xaqmldatepicker.enabled = false
        } else {
            date.setFullYear(parseInt(text.substr(0,4), 10), parseInt(text.substr(5,2), 10)-1, parseInt(text.substr(8,2), 10))
            date.setHours(parseInt(text.substr(11,2), 10))
            date.setMinutes(parseInt(text.substr(14,2), 10))
            date.setSeconds(parseInt(text.substr(17,2), 10))

//            console.debug(date.toGMTString())

            xaqmldatepicker.enabled = true
            setDatePicker(date)
        }

//        if (date == null) console.debug("date is null")
//        else setDatePicker(date)
    }

    function activateExtensionPanel(extensionid) {
//        console.debug("QML++ activateExtensionPanel")

        // 0 = xaqmladdressbookpicker
        // 1 = xaqmlfoldertypeandpicker
        // 2 = xaqmlfolderstatuspicker - removed
        // 3 = xaqmldatepicker
        // 4 = xaqmlfoldersettingspicker

        var extensionOnOff = [false, false, false, false, false];
        extensionOnOff[extensionid] = true;

        xaqmladdressbookpicker.visible = extensionOnOff[0]
        xaqmlfoldertypepicker.visible = extensionOnOff[1]
        xaqmldatepicker.visible = extensionOnOff[3]
        xaqmlfoldersettingspicker.visible = extensionOnOff[4]
    }

    function setActiveInputFieldByID(fieldid) {
//        console.debug("QML++ setActiveInputFieldByID to ID:" + fieldid)

        var activeColor = "#222222"
        var deactivatedColor = "#00000000"

        fieldChange = true

        if (windowDisplaysItemOfType == "P") {
            // deactivate all
            framedTextInputFolderType.deactivateControl()
            framedTextInputStartDate.deactivateControl()
            framedTextInputDueDate.deactivateControl()

            framedTextInputDefaultItemSettings.deactivateControl()
            framedTextInputDefaultContext.deactivateControl()
            framedTextInputDefaultRACI_R.deactivateControl()
            framedTextInputDefaultRACI_A.deactivateControl()
            framedTextInputDefaultRACI_C.deactivateControl()
            framedTextInputDefaultRACI_I.deactivateControl()

            // activate by fieldid
            if (fieldid === 0) {
                framedTextInputFolderType.activateControl()

                activateExtensionPanel(1)
                xaqmlfoldertypepicker.folderFlagged = (collectionFolderFlagged == "1") ? true : false;
                xaqmlfoldertypepicker.folderTypeString = collectionFolderType

            } else if (fieldid == 1) {

            } else if (fieldid == 2) {
                setDatePickerFromString(collectionDTSStartSQLDate)
                framedTextInputStartDate.activateControl()

                activateExtensionPanel(3)
            } else if (fieldid == 3) {
                setDatePickerFromString(collectionDTSDueSQLDate)
                framedTextInputDueDate.activateControl()

                activateExtensionPanel(3)
            } else if (fieldid == 4) {
                framedTextInputDefaultItemSettings.activateControl()

                activateExtensionPanel(4)
                xaqmlfoldersettingspicker.folderDefaultItemPriorityString = collectionDefaultItemPriority
                xaqmlfoldersettingspicker.folderDefaultItemTypeString = collectionDefaultItemType
                xaqmlfoldersettingspicker.folderDefaultItemSecurityLevel = collectionDefaultItemSecurity

            } else if (fieldid == 5) {
                framedTextInputDefaultContext.activateControl()

                activateExtensionPanel(0)
            } else if (fieldid == 6) {
                framedTextInputDefaultRACI_R.activateControl()
                activateExtensionPanel(0)

            } else if (fieldid == 7) {
                framedTextInputDefaultRACI_A.activateControl()
                activateExtensionPanel(0)

            } else if (fieldid == 8) {
                framedTextInputDefaultRACI_C.activateControl()
                activateExtensionPanel(0)

            } else if (fieldid == 9) {
                framedTextInputDefaultRACI_I.activateControl()
                activateExtensionPanel(0)

            }
        } else if (windowDisplaysItemOfType == "C") {
            // deactivate all
            framedTextContextContactName.deactivateControl();
            framedTextContextContactEmail.deactivateControl();
            framedTextContextContactPhone.deactivateControl();
            framedTextContextContactOrganization.deactivateControl();
            framedTextContextContactDivision.deactivateControl();

            framedTextContextLocationName.deactivateControl();
            framedTextContextLocationStreet.deactivateControl();
            framedTextContextLocationCity.deactivateControl();
            framedTextContextLocationZIP.deactivateControl();
            framedTextContextLocationCountry.deactivateControl();

            if (fieldid === 0) framedTextContextContactName.activateControl(true);
            else if (fieldid == 1) framedTextContextContactEmail.activateControl(true);
            else if (fieldid == 2) framedTextContextContactPhone.activateControl(true);
            else if (fieldid == 3) framedTextContextContactOrganization.activateControl(true);
            else if (fieldid == 4) framedTextContextContactDivision.activateControl(true);

            else if (fieldid == 5) framedTextContextLocationName.activateControl(true);
            else if (fieldid == 6) framedTextContextLocationStreet.activateControl(true);
            else if (fieldid == 7) framedTextContextLocationCity.activateControl(true);
            else if (fieldid == 8) framedTextContextLocationZIP.activateControl(true);
            else if (fieldid == 9) framedTextContextLocationCountry.activateControl(true);
        }

        activeInputFieldID = fieldid

        fieldChange = false
    }

    Rectangle {
        id: windowRect
        color: "transparent"

        radius: 6
        smooth: true
        anchors.fill: parent
        anchors.rightMargin: (dtsEditor.platformID == "WIN" ? 1 : 0)
        anchors.bottomMargin: (dtsEditor.platformID == "WIN" ? 1 : 0)

    //
    // window title bar
    //

    XAWindowTitleBar {
        id: xaWindowTitleBar
        windowTitle: dtsEditor.windowTitle
        windowGotFocus: dtsEditor.windowGotFocus
        windowDrawBorder: (dtsEditor.platformID == "WIN")
        platformID: dtsEditor.platformID
    }

    Item {
        id: tabProjectDetailsEditor
        anchors.fill: parent

        //
        // TITLE: Project Collection
        //

        Rectangle {
            id: titleCollection
            x: 20
            y: 28
            width: 300
            height: 35
            color: "#00000000"

            Text {
                id: titleCollection_labelShadow
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 1

                text: qsTr("Project")
                color: "black"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }

            Text {
                id: titleCollection_label
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top

                text: qsTr("Project")
                color: "white"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }
        }

        //
        // dts input frame
        //

        Rectangle {
            id: dtsInputRect
            x: 0
            y: titleCollection.y + 10
            width: 300
            color: "#00000000"

            XAFramedTextInput {
                id: framedTextInputFolderType
                label: qsTr("Type and Status:")

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(0)
            }

            XAFramedTextInput {
                id: framedTextInputStartDate
                label: qsTr("Start Date:")
                text: dtsEditor.collectionDTSStart

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                //anchors.topMargin: 75
                anchors.topMargin: 45
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(2)
            }

            XAFramedTextInput {
                id: framedTextInputDueDate
                label: qsTr("Due Date:")
                text: dtsEditor.collectionDTSDue

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                //anchors.topMargin: 105
                anchors.topMargin: 75
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(3)
            }

        }

        //
        // TITLE: Defaults
        //

        Rectangle {
            id: titleDefaults
            x: 20
            y: 185
            width: 300
            height: 35
            color: "#00000000"

            Text {
                id: titleDefaults_labelShadow
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 1

                text: qsTr("Defaults")
                color: "black"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }

            Text {
                id: titleDefaults_label
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top

                text: qsTr("Defaults")
                color: "white"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }
        }

        //
        // Settings & Context input frame
        //

        Rectangle {
            id: contextInputRect
            x: 0
            y: titleDefaults.y + 10
            width: 300
            color: "#00000000"

            XAFramedTextInput {
                id: framedTextInputDefaultItemSettings
                label: qsTr("Item Settings:")

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(4)
            }

            XAFramedTextInput {
                id: framedTextInputDefaultContext
                label: qsTr("Context:")
                text: dtsEditor.collectionDefaultContext

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 45
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: {
                    setActiveInputFieldByID(5)
                    QtHandler.setContextModelNeedsRefreshWithType("")
                }
            }

        }


        //
        // RACI input frame
        //

        Rectangle {
            id: raciInputRect
            x: 0
            y: contextInputRect.y + 75
            width: 300
            height: 135
            color: "#00000000"

            XAFramedTextInput {
                id: framedTextInputDefaultRACI_R
                label: qsTr("Responsible:")
                text: dtsEditor.raciResponsible

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 10
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: {
                    setActiveInputFieldByID(6)
                    QtHandler.setContextModelNeedsRefreshWithType("R")
                }
            }

            XAFramedTextInput {
                id: framedTextInputDefaultRACI_A
                label: qsTr("Accountable:")
                text: dtsEditor.raciAccountible

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 40
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: {
                    setActiveInputFieldByID(7)
                    QtHandler.setContextModelNeedsRefreshWithType("A")
                }
            }

            XAFramedTextInput {
                id: framedTextInputDefaultRACI_C
                label: qsTr("Consulted:")
                text: dtsEditor.raciConsulted

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 70
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: {
                    setActiveInputFieldByID(8)
                    QtHandler.setContextModelNeedsRefreshWithType("C")
                }
            }

            XAFramedTextInput {
                id: framedTextInputDefaultRACI_I
                label: qsTr("Informed:")
                text: dtsEditor.raciInformed

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 100
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: {
                    setActiveInputFieldByID(9)
                    QtHandler.setContextModelNeedsRefreshWithType("I")
                }
            }
        }

        //
        // Date Picker
        //
        Rectangle {
            id: markerDatePickerRect
            anchors.left: parent.left
            anchors.leftMargin: 300
            anchors.top: parent.top
            anchors.topMargin: 22
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 5
            color: "#222222"
            radius: 10
            opacity: 1.0

            function zeroPad(num,count) {
                var numZeropad = num + '';
                while(numZeropad.length < count) {
                    numZeropad = "0" + numZeropad;
                }
                return numZeropad;
            }

            function composeDTSFromSelection() {
                var newDTS = ""

                if (xaqmldatepicker.enabled) {
                    //newDTS = zeroPad(xaqmldatepicker.theYear, 4) + "-" + zeroPad(xaqmldatepicker.theMonth, 2) + "-" + zeroPad(xaqmldatepicker.theDay, 2);
                    newDTS = zeroPad(xaqmldatepicker.displayYear, 4) + "-" + zeroPad(xaqmldatepicker.displayMonth, 2) + "-" + zeroPad(xaqmldatepicker.theDay, 2);
                    newDTS += " " + zeroPad(xaqmldatepicker.theTime.substring(0,2), 2) + ":" + zeroPad(xaqmldatepicker.theTime.substring(3,5), 2) + ":00";

                    var d = new Date()
//                    console.debug(d)

                    var off = d.getTimezoneOffset()
                    var gmtHours

                    if (off < 0) { newDTS += " +"; gmtHours = -d.getTimezoneOffset()/60; }
                    else { newDTS += " -"; gmtHours = d.getTimezoneOffset()/60; }

                    newDTS += zeroPad(gmtHours, 2) + "00"
                }

                return newDTS;
            }

            function updateDateBySelection() {
//                console.debug("updateDateBySelection")

                var newDTS = composeDTSFromSelection();
//                console.debug(newDTS)

                if (activeInputFieldID == 2) {
                    QtHandler.ReviewDataChangedForField("start_dt", newDTS)

                } else if (activeInputFieldID == 3) {
                    QtHandler.ReviewDataChangedForField("end_dt", newDTS)
                }

                setDatePickerFromString(newDTS)
            }

            XAQMLDatePicker2 {
                id: xaqmldatepicker
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                enabled: true
                visible: false

                onDateSelected: if (!fieldChange) parent.updateDateBySelection()
            }

            XAQMLFolderTypeAndStatusPicker {
                id: xaqmlfoldertypepicker
                x: 0
                y: 0
                width: 250
                height: 364
                anchors.topMargin: -47
                transformOrigin: Item.Center

                anchors.top: parent.top
                anchors.centerIn: parent

                enabled: true
                visible: false

                onFolderFlaggingUpdated: QtHandler.ReviewDataChangedForField("flagged", folderFlaggedResult)
                onFolderTypeStringResultUpdated: QtHandler.ReviewDataChangedForField("category", folderTypeString)
                onFolderTrafficLightStringResultUpdated: QtHandler.ReviewDataChangedForField("status", folderTrafficLightString)
                onFolderActivityStringResultUpdated: QtHandler.ReviewDataChangedForField("runstatus", folderActivityString)
            }

            XAQMLFolderSettingsPicker {
                id: xaqmlfoldersettingspicker
                x: 0
                y: 0
                width: 250
                height: 364
                anchors.topMargin: -47
                transformOrigin: Item.Center

                anchors.top: parent.top
                anchors.centerIn: parent

                enabled: true
                visible: false

                onFolderDefaultItemPriorityStringResultUpdated: QtHandler.ReviewDataChangedForField("task_priority", folderDefaultItemPriorityString)
                onFolderDefaultItemTypeStringResultUpdated: QtHandler.ReviewDataChangedForField("task_type", folderDefaultItemTypeString)
                onFolderDefaultItemSecurityLevelResultUpdated: QtHandler.ReviewDataChangedForField("protectionlevel", folderDefaultItemSecurityLevel)
            }

            XAQMLAddressBookPicker {
                id: xaqmladdressbookpicker
                x: 0
                y: 0
                width: 250
                height: 364
                anchors.topMargin: -47
                transformOrigin: Item.Center

                anchors.top: parent.top
                anchors.centerIn: parent
                enabled: true
                visible: false

                onEntrySelectionChanged: {
                    contextAssignmentChanged();
                }

            }
        }
    }

    Item {
        id: tabContextDetailsEditor
        anchors.fill: parent

        //
        // TITLE: Contact
        //

        Rectangle {
            id: titleContact
            x: 20
            y: 28
            width: 300
            height: 35
            color: "#00000000"

            Text {
                id: titleContact_label
                anchors.fill: parent

                text: qsTr("Contact")
                color: "white"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }
        }

        //
        // Contact input frame
        //

        Rectangle {
            id: contactInputRect
            x: 0
            y: titleContact.y + 10
            width: 300
            color: "#00000000"

            XAFramedTextInput {
                id: framedTextContextContactName
                label: qsTr("Name:")
                text: dtsEditor.contextContactName

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(0)
                onTextChanged: QtHandler.ReviewDataChangedForField("adr_acronym", text)

                onTab: framedTextContextContactEmail.setFocus()
                onBacktab: framedTextContextLocationCountry.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextContactEmail
                label: qsTr("Email:")
                text: dtsEditor.contextContactEmail

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 45
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(1)
                onTextChanged: QtHandler.ReviewDataChangedForField("adr_email", text)

                onTab: framedTextContextContactPhone.setFocus()
                onBacktab: framedTextContextContactName.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextContactPhone
                label: qsTr("Phone:")
                text: dtsEditor.contextContactPhone

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 75
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(2)
                onTextChanged: QtHandler.ReviewDataChangedForField("adr_phone", text)

                onTab: framedTextContextContactOrganization.setFocus()
                onBacktab: framedTextContextContactEmail.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextContactOrganization
                label: qsTr("Organization:")
                text: dtsEditor.contextContactOrganization

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 105
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(3)
                onTextChanged: QtHandler.ReviewDataChangedForField("adr_company", text)

                onTab: framedTextContextContactDivision.setFocus()
                onBacktab: framedTextContextContactPhone.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextContactDivision
                label: qsTr("Division:")
                text: dtsEditor.contextContactDivision

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 135
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(4)
                onTextChanged: QtHandler.ReviewDataChangedForField("adr_division", text)

                onTab: framedTextContextLocationName.setFocus()
                onBacktab: framedTextContextContactOrganization.setFocus()
            }

        }

        //
        // TITLE: Location
        //

        Rectangle {
            id: titleLocation
            x: 20
            y: 215
            width: 300
            height: 35
            color: "#00000000"

            Text {
                id: titleLocation_label
                anchors.fill: parent

                text: qsTr("Location")
                color: "white"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }
        }

        //
        // Location input frame
        //

        Rectangle {
            id: locationInputRect
            x: 0
            y: titleLocation.y + 10
            width: 300
            color: "#00000000"

            XAFramedTextInput {
                id: framedTextContextLocationName
                label: qsTr("Location:")
                text: dtsEditor.contextLocationName

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(5)
                onTextChanged: QtHandler.ReviewDataChangedForField("location_name", text)

                onTab: framedTextContextLocationStreet.setFocus()
                onBacktab: framedTextContextContactDivision.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextLocationStreet
                label: qsTr("Street:")
                text: dtsEditor.contextLocationStreet

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 45
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(6)
                onTextChanged: QtHandler.ReviewDataChangedForField("location_street", text)

                onTab: framedTextContextLocationCity.setFocus()
                onBacktab: framedTextContextLocationName.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextLocationCity
                label: qsTr("City:")
                text: dtsEditor.contextLocationCity

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 75
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(7)
                onTextChanged: QtHandler.ReviewDataChangedForField("location_city", text)

                onTab: framedTextContextLocationZIP.setFocus()
                onBacktab: framedTextContextLocationStreet.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextLocationZIP
                label: qsTr("ZIP:")
                text: dtsEditor.contextLocationZIP

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 105
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(8)
                onTextChanged: QtHandler.ReviewDataChangedForField("location_zip", text)

                onTab: framedTextContextLocationCountry.setFocus()
                onBacktab: framedTextContextLocationCity.setFocus()
            }

            XAFramedTextInput {
                id: framedTextContextLocationCountry
                label: qsTr("Country:")
                text: dtsEditor.contextLocationCountry

                anchors.left: parent.left
                anchors.leftMargin: 20
                anchors.top: parent.top
                anchors.topMargin: 135
                anchors.right: parent.right
                anchors.rightMargin: -10

                onFocusReceived: setActiveInputFieldByID(9)
                onTextChanged: QtHandler.ReviewDataChangedForField("location_country", text)

                onTab: framedTextContextContactName.setFocus()
                onBacktab: framedTextContextLocationZIP.setFocus()
            }

        }

        //
        // Location Picker
        //
        Rectangle {
            id: markerLocationPickerRect
            anchors.left: parent.left
            anchors.leftMargin: 300
            anchors.top: parent.top
            anchors.topMargin: 22
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 5
            color: "#222222"
            //color:  "green"
            radius: 10
            opacity: 1.0

            Rectangle {
                id: previewMapRect
                anchors.left: parent.left
                anchors.leftMargin: 7
                anchors.top: parent.top
                anchors.topMargin: 7
                width: 110
                height: 22
                color: "black"
                border.color: "white"
                border.width: 1
                smooth: true
                radius: 3

                property color textColor: "white"

                Text {
                    id: previewMapLabel
                    anchors.fill: parent
                    color: parent.textColor
                    text: qsTr("Preview Map")
                    font.bold: true
                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter
                    smooth: true
                }

                MouseArea {
                    id: previewMapMouseArea
                    anchors.fill: parent

                    onClicked: {
                        locationWebview.url =""
                        locationWebviewPlaceholder.visible = false
                        locationWebview.visible = true
                        //locationWebview.url = "http://maps.google.com/maps/api/staticmap?center=" + contextLocationStreet + "," + contextLocationCity + "," + contextLocationCountry + "&zoom=14&size=236x362&maptype=roadmap&markers=color:red%7Clabel:P%7C|"+ contextLocationStreet + "+13," + contextLocationCity + "," + contextLocationCountry + "&sensor=false";
                        locationWebview.url = "http://maps.google.com/maps/api/staticmap?center=" + framedTextContextLocationStreet.text + "," + framedTextContextLocationCity.text + "," + framedTextContextLocationCountry.text + "&zoom=14&size=236x362&maptype=roadmap&markers=color:red%7Clabel:P%7C|"+ framedTextContextLocationStreet.text + "," + framedTextContextLocationCity.text + "," + framedTextContextLocationCountry.text + "&sensor=false";
                    }
                    onPressed: { parent.color = "white"; parent.textColor = "black" }
                    onReleased: { parent.color = "black"; parent.textColor = "white" }
                }
            }

            Rectangle {
                id: loadInBrowserRect
                //anchors.left: parent.left
                //anchors.leftMargin: 140
                anchors.right: parent.right
                anchors.rightMargin: 7
                anchors.top: parent.top
                anchors.topMargin: 7
                width: 110
                height: 22
                color: "black"
                border.color: "white"
                border.width: 1
                smooth: true
                radius: 3

                property color textColor: "white"

                Text {
                    id: loadInBrowserLabel
                    anchors.fill: parent
                    color: parent.textColor
                    text: qsTr("Open Map")
                    font.bold: true
                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter
                    smooth: true
                }

                MouseArea {
                    id: loadInBrowserMouseArea
                    anchors.fill: parent

                    onClicked: {
                        Qt.openUrlExternally("http://maps.google.com/maps/?q=" + contextLocationStreet + "," + contextLocationCity + "," + contextLocationCountry)
                    }
                    onPressed: { parent.color = "white"; parent.textColor = "black" }
                    onReleased: { parent.color = "black"; parent.textColor = "white" }
                }
            }

            Rectangle {
                id: locationWebviewPlaceholder
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 7
                anchors.topMargin: 38
                anchors.leftMargin: 7
                anchors.rightMargin: 7

                color: "#55555555"
                border.color: "#99999999"
                clip: true
                radius: 8

                Text {
                    id: locationWebviewPlaceholderText
                    anchors.top: parent.top
                    anchors.left: parent.left
                    anchors.leftMargin: 10
                    anchors.right: parent.right
                    anchors.rightMargin: 10
                    anchors.bottom: parent.bottom
                    anchors.fill: parent
                    wrapMode: Text.Wrap
                    color: "lightgray"

                    //font.family: "Helvetica, Arial"
                    font.family: "Arial"
                    font.pixelSize: 11
                    smooth: true

                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter

                    text: qsTr("Select <b>'Preview Map'</b> to preview the address using Google Maps in this area.<br><br>Select <b>'Open Map'</b> to open the Map in your Web Browser.")
                }

            }

            WebView {
                id: locationWebview
                //anchors.fill: parent
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 7
                anchors.topMargin: 38
                anchors.leftMargin: 7
                anchors.rightMargin: 7

                clip: true
                url: ""
                visible: false
            }
        }
    }

    Item {
        id: tabInternalDetailsEditor
        anchors.fill: parent

        //
        // TITLE: Internal Object
        //
        Text {
            id: titleInternalObject_labelShadow
            //anchors.fill: parent

            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
            anchors.verticalCenterOffset: 1

            text: qsTr("Internal Object")
            color: "black"
            font.family: "Arial"
            //font.pointSize: 14
            font.pixelSize: 14
            font.bold: true
            smooth: true
        }

        Text {
            id: titleInternalObject_label
            //anchors.fill: parent

            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter

            text: qsTr("Internal Object")
            color: "white"
            font.family: "Arial"
            //font.pointSize: 14
            font.pixelSize: 14
            font.bold: true
            smooth: true
        }

    }

    Component.onCompleted: {
        updatePanelSelection();
    }
}
}
