import Qt 4.7

Item {
    id: alertViewer
    width: 300
    height: 140
    anchors.fill: parent

    property string alertTitle : qtAlertTitle
    property string alertMessage : qtAlertMessage

    focus: false
    Keys.enabled: true
    Keys.onEscapePressed: QtWindow.hide();

     Rectangle {
         id: rectangle1
         opacity: 1
         color: "#000000"
         radius: 8
         anchors.fill: parent


         //
         // window title bar
         //

         Rectangle {
             id: titlebarRect
             anchors.left: parent.left
             anchors.right: parent.right
             height: 18
             radius: 8
             opacity: 2.0
             color:  "#222222"
             anchors.top: parent.top

             Rectangle {
                 id: titleBarBottomRect
                 height: 9
                 color:  "#222222"
                 anchors.right: parent.right
                 anchors.left: parent.left
                 anchors.top: parent.top
                 anchors.topMargin: 9
             }

             Text {
                 id: labelWindowTitle
                 anchors.right: parent.right
                 anchors.left: parent.left
                 anchors.leftMargin: 25
                 anchors.top: parent.top
                 height: 20
                 color: "#a8a8a8"
                 text: alertViewer.alertTitle
                 clip: true
                 font.family: "Arial Black"
                 //font.pointSize: 9
                 font.pixelSize: 9
                 verticalAlignment: Text.AlignVCenter
                 horizontalAlignment: Text.AlignHCenter
                 smooth: true
             }

             MouseArea {
                 id: titlebarDragArea
                 x: 0
                 y: 0
                 width: 300
                 height: 18
                 clip: false
                 visible: true
                 anchors.right: parent.right
                 anchors.left: parent.left
                 anchors.top: parent.top
                 acceptedButtons: Qt.LeftButton

                 onPressed: {
                     QtHandler.startMoveTrigger(mouseX, mouseY)
                 }
                 onPositionChanged: {
                     QtHandler.moveTrigger(mouseX, mouseY);
                 }
             }

             Image {
                 id: titlebarCloseImage
                 x: 8
                 y: 4
                 width: 11
                 height: 11
                 source: "imports/WebBrowserContent/pics/display.png"

                 MouseArea {
                     id: titlebarCloseImageMouseArea
                     anchors.fill: parent

                     onClicked: {
                         QtWindow.hide()
                     }
                 }
             }
         }


         //
         // Alert Message
         //

         Text {
             id: alertText
             anchors.fill: parent
             anchors.topMargin: 20
             anchors.leftMargin: 10
             anchors.rightMargin: 10
             anchors.bottomMargin: 10
             text: alertViewer.alertMessage
             wrapMode: Text.WordWrap
             font.pixelSize: 12
             font.family: "AppleGothic"
             verticalAlignment: Text.AlignVCenter
             horizontalAlignment: Text.AlignHCenter
             smooth: true
             color: "#a8a8a8"
         }


     }

 }
